// I N C L U D E S ////////////////////////////////////////////////////////////

#include "./includes.h"
#include "./sample.h"
#include "./lw.c"
#include "./terrain.h"

// F U N C T I O N S //////////////////////////////////////////////////////////

float sc=1.0;
lwObject *ob;

void draw_fn()
  {
  int a,b,c;
  if (new)
    {
    glClearColor( 0.40, 0.40, 0.86, 1.00 );
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    new=0;
    }
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  glPushMatrix();
  glTranslatef(0,0,-10);
  glRotatef(count,0,0,1);
  glRotatef(count/1.31,0,1,0);
  glRotatef(count/1.74,1,0,1);
  glScalef(sc,sc,sc);
  glLightfv(GL_LIGHT0, GL_POSITION, light_pos);


  lw_object_show(ob);

  glutSwapBuffers();
  glPopMatrix();
  }

void idle_fn()
  {
  int a;
  count+=2.63;
  glutPostRedisplay();
  }

void mouse_fn(int button, int state, int x, int y)
  {
  if ((button==GLUT_LEFT_BUTTON)&&(state==GLUT_DOWN))
    {
    sc*=2;
    }
  else if ((button==GLUT_RIGHT_BUTTON)&&(state==GLUT_DOWN))
    {
    sc/=2;
    }
  }

// M A I N //////////////////////////////////////////////////////////////

int main(int argc, char **argv)
  {
  int a;
  srandom(time(0));
//  srandom(1);
  glutInit(&argc,argv);
  glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
  glutInitWindowSize(SCREEN_WIDTH,SCREEN_HEIGHT);
  glutCreateWindow("Freeciv GL Terrain");
  glutDisplayFunc(draw_fn);
  glutIdleFunc(idle_fn);
  glutMouseFunc(mouse_fn);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
  glEnable(GL_DEPTH_TEST);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_NORMALIZE);
  glEnable(GL_AUTO_NORMAL);
  glEnable(GL_COLOR_MATERIAL);
  glColorMaterial(GL_FRONT_AND_BACK,GL_DIFFUSE);
  glShadeModel(GL_FLAT);
//  glEnableClientState(GL_COLOR_ARRAY);
//  glEnableClientState(GL_VERTEX_ARRAY);
//  glEnableClientState(GL_NORMAL_ARRAY);
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_FASTEST);
  glMatrixMode(GL_PROJECTION);
  gluPerspective(45.0,1.0,1.0,10000.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();

  ob=lw_object_read(argv[1]);
  glutMainLoop();
  }
